/***************************************************************************
                          flmonview.h  -  description
                             -------------------
    begin                : Sat Mar 24 2001
    copyright            : (C) 2001 by Christian Traber
    email                : christian@traber-net.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FLMONVIEW_H
#define FLMONVIEW_H

#define VERSION "0.41"
#define APPNAME "FL-Mon"

#define FREQU 1.000
//#define FREQU 1000 /* unsigned int version of add_timeout in ms */

#define FLASHSIZE 3328.0
#define FLASHDIR "/flash"
#define MEMFILE "/proc/meminfo"
#define STATFILE "/proc/stat"

#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <string>
#include <map>
#include <sys/sysinfo.h>


#include <flpda/Widget_Factory.h>
#include <flpda/pref.h>

#include <FL/Fl_Output.H>
#include <FL/Fl_Slider.H>
#include <FL/Fl_Choice.H>
#include <FL/Fl_Button.H>
#include <FL/filename.H>

#include "myabout.h"

/**
  *@author Christian Traber
  */

class flmonView {
public: 
  void open();
	flmonView();
	~flmonView();
private: // Private attributes
  /** main window */
  Fl_App_Window * window;
	Fl_Output * memtext, * flashtext, * cputext, * battext, * uptime;
	Fl_Slider * mem, * flash, * cpu, * bat;
	Fl_Choice * battype;

	double old_nice, old_sys, old_user, old_idle;

private: // Private methods
  /** toolbar */
  void tools();
  /** size of driectory */
  float getDirUsage(char* dir);
  /** cpu usage in % */
  float getCpuStat();
  /** get battype from file */
  int readBattype();
  /** free mem in % */
  float getMemStat();
  /** No descriptions */
  float batvoltage();
  /** get battery usage in % */
  float battlvl(float volts, int battype);
  /** No descriptions */
  void updateValues();
  /** write battype to file */
  void writeBattype(int type);
  /** timer callback */
  static void timer_cb(void*);
  /** refresh button */
  static void refresh_cb(Fl_Widget*,void* data);
  /** done button */
  static void done_cb(Fl_Widget*, void* data);
  /** about button */
  static void about_cb(Fl_Widget*, void* data);
  /** get Uptime */
  void getUptime(char *);

};

#endif

